#include <Servo.h>
Servo yourservo; // declare a servo variable
int pinTrig = 2;
int pinEcho = 3;
int pinServo = 6;
long temps;
float distance,distance1,distance2;


void setup() {
  pinMode(pinTrig, OUTPUT); // define PinTring as an OUTPUT
  pinMode(pinEcho, INPUT); // define PinTring as an INPUT
  digitalWrite(pinTrig, LOW); // define the initial state of pinTrig as LOW
  Serial.begin(9600); // define the speed of communication
  yourservo.attach(pinServo);

}

void loop() {
  digitalWrite(pinTrig, HIGH); // to make the ultrasonic sensor send a ultrasonic wave we have to put the pinTring in a HIGH state for 10 microseconds and then put it in LOW state
  delayMicroseconds(10);
  digitalWrite(pinTrig, LOW);
  temps = pulseIn(pinEcho, HIGH); // we recover the duration between the moment of emission and reception of the wave
  temps = temps/2;
  distance = (temps*340)/10000.0;
  Serial.print("Distance: ");
  Serial.print(distance);
  Serial.println(" cm");

  digitalWrite(pinTrig, HIGH); // to solve the problem of the parasitic distance values, three values are measured
  delayMicroseconds(10);
  digitalWrite(pinTrig, LOW);
  temps = pulseIn(pinEcho, HIGH);
  temps = temps/2;
  distance1 = (temps*340)/10000.0;
  Serial.print("Distance: ");
  Serial.print(distance1);
  Serial.println(" cm");

  digitalWrite(pinTrig, HIGH);
  delayMicroseconds(10);
  digitalWrite(pinTrig, LOW);
  temps = pulseIn(pinEcho, HIGH);
  temps = temps/2;
  distance2 = (temps*340)/10000.0;
  Serial.print("Distance: ");
  Serial.print(distance2);
  Serial.println(" cm");

  if ((distance < 7 ) and (distance1 < 7 ) and (distance2 < 7 )) // all the three distances should be less than 7cm so the enclosure can open
  {
  delay(1000); // wait a second so the user can put his hand under the container 
  yourservo.write(65); // open the enclosure and wait 0.4 seconds then close
  delay(400);
  yourservo.write(110);
  delay(4000);} // wait four seconds so the user can take his candy without opening the enclosure

}
